## bed-3.0.0.src.tar.xz

=== Makefile ===
ifeq ($(findstring Windows,$(OS)),Windows)
OpSys=Windows
endif
include config 
include prognames.mk
#MAKE=gmake
ifneq ($(CONFIG_PLUGIN),y)
ifneq ($(filter disass.plug,$(LINKIN) $(LINKINDYN)),)
DISASS_USE=y
endif
endif

REGEX_DIR=regex-0.13

ifneq ($(HAS_RE_SEARCH),y)
REGEX=src/regex.o
else
REGEX=
endif

ifeq ($(CONFIG_PROGMAN),y)
all:  has_appl has_file $(REGEX) $(CONFFILE) bed.menu 
else
all:  has_appl has_file $(REGEX) $(CONFFILE) 

endif

ifeq ($(BIOSDISK),y)
	$(MAKE) -C biosdisk 
endif
	$(MAKE) -C utils
	$(MAKE) -C plugins/examples  inlinklist plughelp
	$(MAKE) -C src
ifeq ($(CONFIG_PLUGIN),y)
	$(MAKE) -C plugins/examples  give
else
ifeq ($(DISASS_USE),y)
	$(MAKE) -C plugins/examples  disass-use
endif
endif


ifeq ($(CONFIG_XBED),y)
	$(MAKE) -C x11 $(XPROGRAM)
endif
	$(MAKE) -C doc

BEDBASE=$(PROGRAM)-$(VERSION)
LSMFILE=$(PROGRAM)-$(VERSION).lsm
SPECFILE=$(PROGRAM)-$(VERSION).spec

ROOTDIR:=$(abspath $(DESTDIR))

root:
	echo $(ROOTDIR)

ifeq ($(CONFIG_XBED),y)
XBEDMAN=$(ROOTDIR)$(MANDIR)/xbed.1 $(ROOTDIR)$(BINDIR)/xbed
endif
ifeq ($(CONFIG_PROGMAN),y)
MENUBED=$(ROOTDIR)$(MENUPATH)/bed
endif

ifeq ($(SYSTEM),Linux)
BINDIST=$(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK) $(ROOTDIR)$(BINDIR)/bed $(ROOTDIR)$(MANDIR)/bed.1.gz   $(MENUBED) $(XBEDMAN)
else
BINDIST=$(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK) $(ROOTDIR)$(BINDIR)/bed $(ROOTDIR)$(MANDIR)/bed.1   $(MENUBED) $(XBEDMAN)
endif


has_appl:has_appl.c
	$(TOBUILDCC)  $< -o $@

HAS_APPLICATIONS := $(shell ./has_appl)

has:
	echo $(HAS_APPLICATIONS)
ifneq ($(HAS_APPLICATIONS),)
BINDIST+=$(ROOTDIR)$(HAS_APPLICATIONS)/bed-binary-editor.desktop 
endif
ifeq ($(SYSTEM),FreeBSD)
BINDIST+=$(ROOTDIR)/usr/local/lib/nss_dns.so.1 
endif

#SORT=LC_ALL=C sort
install: installfiles
ifeq ($(DESTDIR),)
ifeq ($(HAS_FILE),y)
	@bash ./addmagic
endif
ifeq ($(CONFIG_PROGMAN),y)
	update-menus
endif
endif

installfiles: $(CONFFILE)  #$(LSMFILE)
ifeq ($(CYGWIN),yes)
	cd "c:\\"
endif
	-$(MKDIR) $(ROOTDIR)$(BINDIR)
	-rm   $(ROOTDIR)$(BINDIR)/$(EXEPROGRAM)
	$(CP) src/$(EXEPROGRAM) $(ROOTDIR)$(BINDIR)
	$(STRIP)  $(ROOTDIR)$(BINDIR)/$(EXEPROGRAM)
	-rm   $(ROOTDIR)$(CONFDIRLINK)
	-mv -f  $(ROOTDIR)$(CONFDIRLINK) $(ROOTDIR)$(CONFDIRLINK).bak
	-$(MKDIR) $(ROOTDIR)$(CONFDIR)
ifneq ($(CYGWIN),yes)
	$(MKDIR) `dirname $(ROOTDIR)$(CONFDIRLINK)`
	-mv  $(ROOTDIR)$(CONFDIR)/$(CONFFILE) $(ROOTDIR)$(CONFDIR)/~$(CONFFILE)
endif
	$(CP) $(CONFFILE) $(ROOTDIR)$(CONFDIR)
	chmod 0644 	$(ROOTDIR)$(CONFDIR)/$(CONFFILE)
	$(MAKE) -C doc install ROOTDIR=$(ROOTDIR)
	$(MAKE) -C misc install ROOTDIR=$(ROOTDIR)
ifeq ($(CONFIG_XBED),y)
	$(MAKE) -C x11 install ROOTDIR=$(ROOTDIR)
endif
ifeq ($(CONFIG_PLUGIN),y)
	$(MAKE) -C utils install ROOTDIR=$(ROOTDIR)
	$(MAKE) -C plugins install ROOTDIR=$(ROOTDIR)

else
ifeq ($(DISASS_USE),y)
	$(CP) plugins/examples/disass-use*  $(ROOTDIR)$(CONFDIR)
endif
endif
ifneq ($(CYGWIN),yes)
ifeq ($(CONFIG_PLUGIN),y)
	-$(SYMLINK) -r  -s $(ROOTDIR)$(BINDIR)/$(PROGRAM) $(ROOTDIR)$(CONFDIR)/utils/keyconfig
else
	-$(SYMLINK) -r  -s $(ROOTDIR)$(BINDIR)/$(PROGRAM) $(ROOTDIR)$(CONFDIR)/keyconfig
endif
else
ifeq ($(BIOSDISK),y)
	$(MAKE) -C biosdisk install ROOTDIR=$(ROOTDIR)
endif
ifeq ($(PDCURSES),)
	echo $(EXEPROGRAM) -k %1 %2 %3 %4 %5 %6 %7 %8 %9 > $(ROOTDIR)$(CONFDIR)/keyconfig.bat
endif
endif
ifeq ($(PDCURSES),)
	$(MKDIR) $(ROOTDIR)$(CONFDIR)/terminfo
	$(MKDIR) $(ROOTDIR)$(CONFDIR)/terminfo/r
	cp   terminfo/r/rxvt* $(ROOTDIR)$(CONFDIR)/terminfo/r
endif
	cp    LICENSE $(ROOTDIR)$(CONFDIR)
ifeq ($(OpSys),Windows)
	u2d     $(ROOTDIR)$(CONFDIR)/LICENSE
endif
	cp doc/datadir.txt $(ROOTDIR)$(CONFDIR)/README
	cp public.pgp $(ROOTDIR)$(CONFDIR)
ifeq ($(SYSTEM),Linux)
	cp bedkeys $(ROOTDIR)$(CONFDIR)
endif
ifeq ($(SYSTEM),FreeBSD)
	cp us.alt.kbd README.FreeBSD $(ROOTDIR)$(CONFDIR)
endif
ifeq ($(SYSTEM),SunOS)
	cp README.OpenSolaris $(ROOTDIR)$(CONFDIR)
endif
ifeq ($(HAS_FILE),y)
	$(CP) testmarks.bedm bedmagic bedmagic.short addmagic $(ROOTDIR)$(CONFDIR)
endif
ifneq ($(HAS_APPLICATIONS),)
	$(MKDIR) $(ROOTDIR)$(HAS_APPLICATIONS)
	cp progman/bed-binary-editor.desktop $(ROOTDIR)$(HAS_APPLICATIONS)/bed-binary-editor.desktop 
endif
ifeq ($(CONFIG_PROGMAN),y)
#	cp bed.xpm $(ROOTDIR)$(ICONPATH)
#	cp bedsmall.xpm $(ROOTDIR)$(ICONPATH)/mini/bed.xpm
	$(MKDIR) $(ROOTDIR)$(MENUPATH)
	cp bed.menu $(ROOTDIR)$(MENUPATH)/$(PROGRAM)
	chmod 0644 $(ROOTDIR)$(MENUPATH)/$(PROGRAM)

#	@rpm -q $(PROGRAM)|| echo Warning!! Desktop entries not created if no package $(PROGRAM) exists
endif
ifneq ($(CYGWIN),yes)

ifeq ($(SYSTEM),FreeBSD)
	$(SYMLINK) -r -f $(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK)
else
	$(SYMLINK) -r -T -f  $(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK)
endif
endif
ifeq ($(SYSTEM),Android)
	-$(MKDIR) $(ROOTDIR)$(BASEDIR)/tmp
	-chmod 01777 $(ROOTDIR)$(BASEDIR)/tmp
endif
ifneq ($(CYGWIN),yes)
	@cp uninstallhead $(ROOTDIR)$(CONFDIR)/uninstallbed.sh
	@FILES=`for afile in $(BINDIST); do  test -e $$afile -o -L $$afile&&echo $$afile ;done`;if test . != .$(ROOTDIR); then SLASHROOT=`echo $(ROOTDIR)| sed -e 's/\\//\\\\\\//g'`;fi;find  $$FILES ! -type d -print |if test . != .$(ROOTDIR);then sed -e "s/$$SLASHROOT//g";else cat;fi |xargs echo $(REMOVE) ' ' >> $(ROOTDIR)$(CONFDIR)/uninstallbed.sh ;find  $$FILES -type d  -a  -print| if test . != .$(ROOTDIR);then sed -e "s/$$SLASHROOT//g";else cat;fi |$(SORT) -r|xargs echo $(RMDIR) ' ' >> $(ROOTDIR)$(CONFDIR)/uninstallbed.sh
	@echo Uninstall with sh $(ROOTDIR)$(CONFDIR)/uninstallbed.sh
endif
	@echo Binary: '$(ROOTDIR)$(BINDIR)/$(EXEPROGRAM)'
	@echo Support files: $(ROOTDIR)$(CONFDIR)



cleanhere:
	-rm  $(REGEX_DIR)/regex.o hosttest$(BUILDEXEEXT) has_appl$(BUILDEXEEXT) has_file$(BUILDEXEEXT)
clean: cleanhere
	$(MAKE) -C src clean
	$(MAKE) -C utils clean
	$(MAKE) -C plugins clean
	$(MAKE) -C x11 clean
	$(MAKE) -C biosdisk clean
	-$(MAKE) -C doc clean
	-$(MAKE) -C man2html clean


realclean: cleanhere
	-rm $(CONFFILE)  config.cache config.bak config.log config.status  bedrc buildonce getsize
	 $(MAKE) -C x11 clean
	$(MAKE) -C src realclean
	- $(MAKE) -C doc realclean
	- $(MAKE) -C man2html clean
	 $(MAKE) -C utils realclean
	 $(MAKE) -C plugins realclean
	 $(MAKE) -C biosdisk realclean
	-rm  $(REGEX_DIR)/regex.o


echo:
	echo $(BINDIST)
.PHONY: %.dist %.bindist %.srcdist %.html
HTMLPATH=../html
DISTPATH=$(HTMLPATH)
TGZSUF=.tar.xz
SRCBASE=$(PROGRAM)-$(VERSION).src
SRCARGFILE=$(SRCBASE)$(TGZSUF)
SRCLSMFILE=$(SRCBASE).lsm
SRCASCFILE=$(SRCBASE).asc
#s/$(TGZSUF)/$(TGZSUF)/g


SOURCEFILE=$(DISTPATH)/download/$(PROGRAM)-$(VERSION).src$(TGZSUF) 
ifeq ($(CONFIG_STATIC),y)
ELFBASE=$(PROGRAM)-$(VERSION).$(SYSTEM).ELF-static$(ELFSIZE)
else
#ELFBASE=$(PROGRAM)_$(VERSION)-$(SYSTEM)
ELFBASE=$(PROGRAM)-$(VERSION).$(SYSTEM)
endif
ELFARGFILE=$(ELFBASE)$(ELFSIZE)$(TGZSUF) 
ELFLSMFILE=$(ELFBASE).lsm
ELFASCFILE=$(ELFBASE).asc
WIN32ARGFILE=$(PROGRAM)-$(VERSION).win32.zip
WIN95ARGFILE=$(PROGRAM)-$(VERSION).win95.zip
#NWIN32ARGFILE=$(PROGRAM)-$(VERSION).win32ncurses.zip
NWIN32ARGFILE=$(PROGRAM)-$(VERSION).win32ncuronly.zip

WIN64ARGFILE=$(PROGRAM)-$(VERSION).win64.zip
NWIN64ARGFILE=$(PROGRAM)-$(VERSION).win64ncuronly.zip


FREEBSDARGFILE=$(PROGRAM)-$(VERSION).FreeBSD64.tbz
#FREEBSDARGFILE=$(PROGRAM)-0.2.22.FreeBSD64$(TGZSUF)
#FREEBSDARGFILE=$(PROGRAM)-0.2.22.FreeBSD64$(TGZSUF)
OPENSOLARISFILE=$(PROGRAM)-$(VERSION).SunOS.tar.xz
STATICARGFILE=$(PROGRAM)-$(VERSION).bin.ELF-static$(TGZSUF)
#NONSTATICARGFILE32=$(PROGRAM)-$(VERSION).Linux32$(TGZSUF)
#NONSTATICARGFILE64=$(PROGRAM)-$(VERSION).Linux64$(TGZSUF)
NONSTATICARGFILE64=$(PROGRAM)_$(VERSION)_amd64.deb
NONSTATICARGFILE32=$(PROGRAM)_$(VERSION)_i386.deb
NONSTATICARGFILE_ARMHF=$(PROGRAM)_$(VERSION)_armhf.deb
ANDROIDARGFILE=$(PROGRAM)-$(VERSION)-arm-android-17.tar.gz
RPMFILE=bed-$(VERSION)-1.i686.rpm

#LSMFILE=$(PROGRAM)-$(VERSION).lsm
FULLELFFILE=$(DISTPATH)/download/$(ELFARGFILE)
#PGPSIGNPROG=gpg -s --use-embedded-filename -a -b -u 0x94BA03AE 
#PGPSIGNPROG=gpg2 -s --use-embedded-filename -b -u 0x94BA03AE 

#PGPSIGNPROG=gpg2 -s   -b -u 0x94BA03AE 

# --use-embedded-filename

#  --comment string

#       --no-comments

#--clearsign


#PGPSIGNPROG= pgps -a -b -u 0x94BA03AE 

PGPSIGNPROG=gpg --cert-digest-algo=SHA256 -s -a  -b -u 0x94BA03AE -u 0x65D385A5 

mkuninstall:
	@cp uninstallhead $(CONFDIR)/uninstallbed.sh
	@FILES=`for afile in $(BINDIST); do  test -e $$afile -o -L $$afile&&echo $$afile ;done`; find  $$FILES ! -type d|xargs echo $(REMOVE) ' ' >> $(CONFDIR)/uninstallbed.sh ;find  $$FILES -type d|$(SORT) -r|xargs echo $(RMDIR) ' ' >> $(CONFDIR)/uninstallbed.sh
#	find  $(BINDIST) -type f|xargs 'echo rm -f '
#	find  $(BINDIST) -type d|$(SORT) -r|xargs 'echo rmdir '

%.bindist: $(BINARIES)
	mkdir -p $*/download
	tar --use-compress-program="xz -ze" -cf $*/download/$(ELFARGFILE)   $(BINDIST) 
#	env VERSION=$(VERSION) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) DISTPATH=$*/download sh ./mklsmelf > $*/download/$(ELFLSMFILE)
%.srcdist:
	mkdir -p $*/download
	tar --use-compress-program="xz -ze" -cf  $*/download/$(PROGRAM)-$(VERSION).src$(TGZSUF)  -C ../  $(PROGRAM)-$(VERSION) 
#	env  ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mklsm > $*/download/$(SRCLSMFILE)
%.html: mkbed 
	mkdir -p $*
	$(MAKE) -C doc bed.html
	cp doc/bed.html $*/bed.1.html
	$(MAKE) -C doc menu.html
	env SRCARGFILE=$(SRCARGFILE) WIN32ARGFILE=$(WIN32ARGFILE)  WIN95ARGFILE=$(WIN95ARGFILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) ANDROIDARGFILE=$(ANDROIDARGFILE) NONSTATICARGFILE_ARMHF=$(NONSTATICARGFILE_ARMHF) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mkbed | sh dseonlyext.sh >$*/download.html
	sh dseext.sh <$*/download.html > $*/downloaddse.html
	env  LOWVERSION=$(LOWVERSION) LSMFILE=$(LSMFILE)  ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mkoldpage.sh > $*/oldbeds.html
	cp doc/menu.html $*/menu.html

#	env  WIN32ARGFILE=$(WIN32ARGFILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mknewlsm > $*/download/$(LSMFILE)
%.dist: %.srcdist %.bindist %.sign
	echo $*




#s/FREEBSDARGFILE/OPENSOLARISFILE/g

%.sign:
	$(PGPSIGNPROG)   --comment $(SRCARGFILE) $*/download/$(SRCARGFILE) 
	$(PGPSIGNPROG)   --comment $(WIN64ARGFILE) $*/download/$(WIN64ARGFILE) 
	$(PGPSIGNPROG)   --comment $(NWIN64ARGFILE) $*/download/$(NWIN64ARGFILE) 
	$(PGPSIGNPROG)   --comment $(WIN32ARGFILE) $*/download/$(WIN32ARGFILE) 
	$(PGPSIGNPROG)   --comment $(NWIN32ARGFILE) $*/download/$(NWIN32ARGFILE) 
	$(PGPSIGNPROG)   --comment $(NONSTATICARGFILE32) $*/download/$(NONSTATICARGFILE32) 
	$(PGPSIGNPROG)   --comment $(NONSTATICARGFILE64) $*/download/$(NONSTATICARGFILE64) 
	$(PGPSIGNPROG)   --comment $(NONSTATICARGFILE_ARMHF) $*/download/$(NONSTATICARGFILE_ARMHF) 
	$(PGPSIGNPROG)   --comment $(ANDROIDARGFILE) $*/download/$(ANDROIDARGFILE) 
#	make $*/download/$(LSMFILE) 

#	$(PGPSIGNPROG)  $*/download/$(STATICARGFILE)
#	env  WIN32ARGFILE=$(win32argfILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mknewlsm > $*/download/$(LSMFILE)

%.lsm: ./settings
	env SRCARGFILE=$(SRCARGFILE) WIN32ARGFILE=$(WIN32ARGFILE)  WIN95ARGFILE=$(WIN95ARGFILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=../html/download bash ./mknewlsm > $*.lsm
