=== debian/changelog ===
bed (3.0.0) stable; urgency=high

  * Faster version of showmarks 
  * Uniformalized search procedures
  * changed plugin searchclip so that is doesn't take over all search options.
  * MS windows: bedrc now in %APPDATA%
  * replace old regex-0.12 with NETBSDs external/gpl3/binutils/dist/libiberty/regex.c and external/gpl3/binutils/dist/include/xregex*.h
  * changed copyselect so recent changes are memorized
  * added unit search and replace
  * doesn't search icase in non ascii, non regex anymore
  * added Keep options to search to save search options
  * Changed regex syntax: regex interpretation now without \: 0{10} now means 0000000000
  * MSWindows: ReadFile and WriteFile in PhysicalDrive[0-9]+ need only work with RAM addresses 
  *   starting at sector boundaries. And one of my hardrives only worked with even addresses, so I 
  *   rearanged everything to comply.
  * color shows search hits
  * libre2 and hyperscan regex
  * nextsearch starts now from cursor position
  * removed MAXUNDO limit
  * sometimes no key input, because of rejecting of * giving negativ intptr_t. Repaired.
  * Alt-f,n (emptyfile) no longer connected to .neededbybed, size can vary
  * use libmagic for instead of file for filetype
  * ANDROID search for temporary file locations
  * compiles with Androids NDK bionic g++ libc
  * float.cc works with sizeof(long double)=8 
  * cross-compiling using ./configure --host=host-type now possible

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 17 Jan 2018 16:46:17 +0100

bed (2.27.2) unstable; urgency=medium

  * end thread without using pthread_cancel(threadsearch), because of problems in win64: closing file during background search end
  * interrupting background search.
  * added  LOGMESSAGE
  * added some read error reporting Editor::fromfile(OFFTYPE pos)
  * Removed some serious errors in Windows NT+ version: 
  * 	-FSCTL_ALLOW_EXTENDED_DASD_IO was not always set after reopening disk.
  * minor changes to make it compile unter cygwin64
  * inconsequental removal of some warning messages
  * change of = to == somewhere

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 13 Sep 2017 17:17:47 +0200

bed (0.2.27) unstable; urgency=medium

  * Removed some size restrictions, can now open linux's /dev/full
  * configASCII byt=maxres
  * getfree now gives a better estimate of free memory
  * made it compile under  64 bits Linux and FreeBSD and 32 bits OpenSolaris x86
  * removed compiler warning, by changing char in unsigned and signed char, changed to const, cast unsigned to int
  * 	etc
  * closes disk handle in disk.cpp
  * set off desturbe.h/.cpp 's locks with USETHREADS. It has only to do with interrupt and isn't mentioned in the background thread, 
  *   so why add it when using multiple threads? And for interrupt to normal course should never wait, interrupt should only succeed when
  * 	it is save to do so.
  * set background searching in win32 version
  * merged some searched functions in memory.cpp and added interrupt posibility under 
  *   cygwin while searching harddisk
  * Switched to windows versions for file attributes (getfiles, filegeg, filedata) en chdir
  * used fullname because cygwin didn't use windows current directory (or so)

 -- Jaap Korthals Altes <bed.dse.nl>  Mon, 26 Jul 2010 11:06:52 +0200

bed (0.2.26) unstable; urgency=medium

  * minor changes in manual en mvtakefile getfile.cc
  * Document->Untitled

 -- Jaap Korthals Altes <bed.dse.nl>  Thu, 13 Aug 2009 10:43:06 +0200

bed (0.2.25) unstable; urgency=medium

  * in getvolumegegs always remove '\' again
  * added Editor::consoleresize
  * ncurses version in windows console sets screenbuffer equal to window size
  * bedrc: TERM=rxvt if COLORTERM=gnome-terminal
  * getotherterm only once when called within 2 seconds
  * %LOCALAPPDATA%
  * makes switchsize.plug switch to smaller above a certain percentage of maximum

 -- Jaap Korthals Altes <bed.dse.nl>  Mon, 05 Jan 2009 15:51:56 +0100

bed (0.2.24) unstable; urgency=medium

  * configure aangepast voor nieuwe pdcurses
  * windows: disk aanduidingen, filedata nu werkend in windows xp/vista
  * removed some code mvtakefile(int ypos,int xpos,const char *com,const char *pat) (file getfile.cpp) which resulted in a endless loop and didn't seem to have a function.
  * made it compile under gcc version 4.3.0 20080428 (Red Hat 4.3.0-8) (GCC) (changed classname:: within class classname, changed x= new (type *)[nr] etc)

 -- Jaap Korthals Altes <bed.dse.nl>  Mon, 22 Dec 2008 22:08:52 +0100

bed (0.2.23) unstable; urgency=medium

  * Added a few changed in memory.cpp, getfile.cpp and disk.cpp to 
  * 	improve raw disk acces under Windows XP: ]
  * 		- determining the size of \\.\PHYSICALDRIVE[0-20]
  * 		- opening raw disk via Alt-f,o
  * 		- faster detection of devices
  * Use new WINDIR (Makefile, config.in) variable
  * Modifies makes now a difference between detecting a different and the
  * 	 occurrance of an error (file.cpp).

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 07 Jul 2004 11:24:30 +0200

bed (0.2.22) unstable; urgency=medium

  * Removed atexit from HANDLE initcursorinfo(void) 
  * Shell in subprogram possible under FreeBSD
  * use real suspend again under Linux 
  * use PAGER if helptext> LINES_USE_PAGER
  * disass paths and install corrected

 -- Jaap Korthals Altes <bed.dse.nl>  Fri, 05 Mar 2004 20:27:02 +0100

bed (0.2.21) unstable; urgency=medium

  * a few unimportant files wrong in uninstall list and archive

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 28 Jan 2004 12:35:31 +0100

bed (0.2.20) unstable; urgency=medium

  * putselect.plug made debugfile /tmp/putselect.txt. changed
  * changed plugins/examples/Makefile a little bit to precompile a few more plugins
  * changed at some places in src/Makefile GCC in GXX
  * Removed struct cast out of src/keyconfig.cpp
  * varmacro.h condition changed
  * change help menus a little bit

 -- Jaap Korthals Altes <bed.dse.nl>  Tue, 27 Jan 2004 17:24:41 +0100

bed (0.2.19) unstable; urgency=medium


