=== debian/control ===
Source: bed
Section: utils
Priority: optional
Maintainer: Jaap Korthals Altes <bed@dse.nl>
Standards-Version: 3.0.0

Package: bed
Architecture: any
Depends: ${shlibs:Depends}
Description: Adjustable data format binary editor
 Adjustable data format binary editor. Data formats are
 ASCII, unsigned and signed integers, float, bit-flags,
 bit-fields, labels, ebcdic and time_t. Different sizes
 and byte orderings are possible. Data types can
 be used in structures. Other data formats, filters and
 procedures can be defined in plugins. Contains copy,
 past, undo, redo, search, replace, marks, record/play and
 context sensitive help. Raw edit of hard drives. Under  
 Linux and FreeBSD even usable without X windows.
